//---------------------------------------------------------------------------

#pragma hdrstop

#define _EXPORTING
#include "..\miniscope\device\MiniscopeDevice.h"
#include "SettingsUnit.h"
#include <assert.h>

//---------------------------------------------------------------------------
#pragma package(smart_init)

static const struct S_DEVICE_DLL_INTERFACE dll_interface =
	{DLL_INTERFACE_MAJOR_VERSION, DLL_INTERFACE_MINOR_VERSION};

// callback ptrs
CALLBACK_LOG lpLogFn = NULL;
CALLBACK_CONNECT lpConnectFn = NULL;
CALLBACK_DATA lpDataFn = NULL;
CALLBACK_TRIGGER lpTriggerFn = NULL;

void *callbackCookie;	///< used by upper class to distinguish library instances when receiving callbacks

void __stdcall GetMiniscopeInterfaceDescription(struct S_DEVICE_DLL_INTERFACE* interf)
{
	interf->majorVersion = dll_interface.majorVersion;
	interf->minorVersion = dll_interface.minorVersion;
}

void __stdcall SetCallbacks(void *cookie, CALLBACK_LOG lpLog, CALLBACK_CONNECT lpConnect,
	CALLBACK_DATA lpData, CALLBACK_TRIGGER lpTrigger)
{
	assert(cookie && lpLog && lpConnect && lpData && lpTrigger);
	lpLogFn = lpLog;
	lpConnectFn = lpConnect;
	lpDataFn = lpData;
	lpTriggerFn = lpTrigger;
	callbackCookie = cookie;
	lpLogFn(callbackCookie, "I'm alive!");
}

void __stdcall GetDeviceCapabilities(struct S_SCOPE_CAPABILITIES *caps)
{

}

void __stdcall ShowSettings(HANDLE parent)
{
	MessageBox(parent, "This dll has no settings.", "Device DLL", MB_ICONINFORMATION);
}

int __stdcall SetSensitivity(int iChannel, int iId)
{

}

int __stdcall SetSamplingPeriod(int iId)
{

}

int __stdcall SetTriggerSource(int iChannel, int iId)
{

}

int __stdcall SetCouplingType(int iChannel, int iId)
{

}

int __stdcall SetBufferSize(int iId)
{

}

int __stdcall SetOffset(int iChannel, float fOffset)
{

}

int __stdcall AcquireStart(void)
{

}

int __stdcall AcquireStop(void)
{

}

int __stdcall ManualTrigger(void)
{

}

